#import "SPApplication.h"
#import "SPWindow.h"

@implementation SPApplication

- ( void )sendEvent: ( NSEvent * )event
{
    NSEventType		type = [ event type ];
	BOOL tabletFlag = NO;
	
	if ( type == NSMouseMoved && [ event deltaY ] < 0.0001 && [ event deltaX ] < 0.0001 ) {
		tabletFlag = YES;
	}

    if ( type != NSAppKitDefined &&
		 type != NSSystemDefined &&
         type != NSApplicationDefined &&
		 type != NSTabletProximity &&
		 ! tabletFlag ) {
		 
		NSLog( @"Got event: %@", [event description] );
        NSLog( @"Quitting" );
		[NSCursor unhide];

		NSEnumerator *e = [[self windows] objectEnumerator];
		SPWindow *window;
		while( window = [e nextObject] ) {
			[window close];
		}

		NSURL *scriptURL = [NSURL fileURLWithPath:[[NSBundle mainBundle] pathForResource:@"runatquit" ofType:@"scpt"]];
		NSAppleScript *theScript = [[NSAppleScript alloc] initWithContentsOfURL:scriptURL error:nil];
		[theScript executeAndReturnError:nil];
		[theScript release];

        exit( 0 );
    } else {
        [ super sendEvent: event ];
    }
}

@end
